// Code generated by smithy-go-codegen DO NOT EDIT.

// Package codecatalyst provides the API client, operations, and parameter types
// for Amazon CodeCatalyst.
//
// Amazon CodeCatalyst is in preview release and subject to change. Welcome to the
// Amazon CodeCatalyst API reference. This reference provides descriptions of
// operations and data types for Amazon CodeCatalyst. You can use the Amazon
// CodeCatalyst API to work with the following objects. Dev Environments and the
// Amazon Web Services Toolkits, by calling the following:
//
// * CreateAccessToken,
// which creates a personal access token (PAT) for the current user.
//
// *
// CreateDevEnvironment, which creates a Dev Environment, where you can quickly
// work on the code stored in the source repositories of your project.
//
// *
// CreateProject which creates a project in a specified space.
//
// *
// CreateSourceRepositoryBranch, which creates a branch in a specified repository
// where you can work on code.
//
// * DeleteDevEnvironment, which deletes a Dev
// Environment.
//
// * GetDevEnvironment, which returns information about a Dev
// Environment.
//
// * GetProject, which returns information about a project.
//
// *
// GetSourceRepositoryCloneUrls, which returns information about the URLs that can
// be used with a Git client to clone a source repository.
//
// * GetSubscription,
// which returns information about the Amazon Web Services account used for billing
// purposes and the billing plan for the space.
//
// * GetUserDetails, which returns
// information about a user in Amazon CodeCatalyst.
//
// * ListDevEnvironments, which
// retrives a list of Dev Environments in a project.
//
// * ListProjects, which
// retrieves a list of projects in a space.
//
// * ListSourceRepositories, which
// retrieves a list of source repositories in a project.
//
// *
// ListSourceRepositoryBranches, which retrieves a list of branches in a source
// repository.
//
// * ListSpaces, which retrieves a list of spaces.
//
// *
// StartDevEnvironment, which starts a specified Dev Environment and puts it into
// an active state.
//
// * StartDevEnvironmentSession, which starts a session to a
// specified Dev Environment.
//
// * StopDevEnvironment, which stops a specified Dev
// Environment and puts it into an stopped state.
//
// * StopDevEnvironmentSession,
// which stops a session for a specified Dev Environment.
//
// * UpdateDevEnvironment,
// which changes one or more values for a Dev Environment.
//
// * VerifySession, which
// verifies whether the calling user has a valid Amazon CodeCatalyst login and
// session.
//
// Security, activity, and resource management in Amazon CodeCatalyst, by
// calling the following:
//
// * DeleteAccessToken, which deletes a specified personal
// access token (PAT).
//
// * ListAccessTokens, which lists all personal access tokens
// (PATs) associated with a user.
//
// * ListEventLogs, which retrieves a list of
// events that occurred during a specified time period in a space.
package codecatalyst
